;*************************************************************************
;-------------------------------------------------------------------------
;				Definierung der Konstanten
;-------------------------------------------------------------------------
.equ	xtal			= 1000000	;1.0MHz (max 3.2MHz)

.equ	MATCH_ROM		= 0x55
.equ	SKIP_ROM		= 0xCC
.equ	SEARCH_ROM		= 0xF0

.equ	CONVERT_T		= 0x44
.equ	READ_T			= 0xBE
.equ	WRITE_T			= 0x4E
.equ	STORE_EE		= 0x48
.equ	RECALL_EE		= 0xB8

.equ	WRITE_SCR		= 0x0F
.equ	READ_SCR		= 0xAA
.equ	COPY_SCR		= 0x55
.equ	READ_RAM			= 0xF0

.equ	SEARCH_FIRST	= 0xFF	; start new search
.equ	PRESENCE_ERR	= 0xFE
.equ	DATA_ERR		= 0xFE
.equ	LAST_DEVICE		= 0x00
				; 0x01 ... 0x7F: continue searching

.equ	GRENZ_HEIZ		= 0x40	;Grenztemp. Heiz. 32.0C(+-1.0C)
.equ	GRENZ_POOL		= 0x38	;Grenztemp. Pool  28.0C(+-0.5C)

;-------------------------------------------------------------------------
;				Using register
;-------------------------------------------------------------------------
.equ	romcode_ptr	= 1		;point to 1 wire address (r1..r8)
.equ	rtc_ptr		= 1		;point to rtc time (r1..r6)
.def	rtc_b0		= r1
.def	rtc_b1		= r2
.def	rtc_b2		= r3
.def	rtc_b3		= r4
.def	rtc_magic0	= r5
.def	rtc_magic1	= r6

.def	SaveSreg	= r9		;for interrupt usage

.equ	temp_ptr	= 10		;point to temperature values
.def	temp1l		= r10		;low byte first
.def	temp1h		= r11
.def	temp2l		= r12
.def	temp2h		= r13
.def	temp3l		= r14
.def	temp3h		= r15

.def	Flags 		= r20		;only bit 7..4 used
.def	key_reg		= r20		;only bit 3..0 used
.equ	fdate		= 5		;display date / temperature
.equ	key_press	= 3

.def	lcd_count	= r22		;count cursor position
.def 	temp2 		= r23
.def 	temp3 		= r24

.def	a0		= r16		;working registers
.def	a1		= r17
.def	a2		= r18		;lcd: a0..a2
.def	a3		= r19		;1wire: a0..a3, zl
