	 ;sendet ein Datenbyte an das LCD

lcd_data:
		   	sbi PORTB, 0
           	out PORTA, a0             ;ausgeben
           	rcall lcd_enable             ;Enable-Routine aufrufen
           	rcall delay50us              ;Delay-Routine aufrufen
           	cbi PORTB, 0
			inc	lcd_count				;zhle Stellen
			sec
		   	ret                          ;zurck zum Hauptprogramm

	 ;sendet einen Befehl an das LCD

lcd_command:                            ;wie lcd_data, nur ohne RS zu setzen
           cbi PORTB,0
		   out PORTA, a0
           rcall lcd_enable
		   rcall delay50us
           ret

	 ;erzeugt den Enable-Puls

lcd_enable:
           sbi PORTB, 1                 ;Enable high
		   ldi temp3, 0x0f
loop_e:	   nop
		   dec temp3
		   brne loop_e	
           cbi PORTB, 1                 ;Enable wieder low
           ret                          ;Und wieder zurck                     

	 ;Pause nach jeder bertragung

delay50us:                              ;50us Pause
           ldi  a0, 50 * xtal /1000000 /3
delay50us_:dec  a0
           brne delay50us_
           ret                          ;wieder zurck

	 ;Lngere Pause fr manche Befehle

delay5ms:                               ;5ms Pause
           ldi  a0, 5000 * xtal /1000000 /500	;5 ms
WGLOOP0:   ldi  temp2, 500 * xtal / 1000000 /3 	;500 us
WGLOOP1:   dec  temp2
           brne WGLOOP1
           dec  a0
           brne WGLOOP0
           ret                          ;wieder zurck

	 ;Initialisierung

lcd_init:
           ldi	temp3,0xaf
powerupwait:
           rcall	delay5ms
           dec	temp3
           brne	powerupwait
           
           ldi a0, 0b00001110        
           rcall lcd_command            
           rcall delay5ms
           ldi a0, 0b00000110       
           rcall lcd_command          
           rcall delay5ms
		   ldi a0, 0b00111000       
           rcall lcd_command
		   ldi a0, 0b00000011
		   rcall lcd_command
		   rcall delay5ms
		   rcall lcd_enable           
           rcall delay5ms
           rcall lcd_enable             
           rcall delay5ms
           ret

	 ;Lschung des Displays

lcd_clear:
           ldi a0, 0b00000001   ;Display lschen
           rcall lcd_command
           rcall delay5ms
           ret

	 ;Punkt

lcd_dot:				;display decimal point
			ldi	a0, '.'
			rcall lcd_data
			ret

	 ;Display Temperature			

display_temp:						;inline !
		clr		lcd_count
		ldi		zl, temp_ptr		;point to temperature value
_dte1:	ld		r0, z				;get low byte
		inc		zl
		ld		a0, z				;get high byte
		inc		zl
		cpi		a0, 0x7F
		breq	_dte3				;no valid value
		brcs	_dte2				;positive value
		ldi 	a0, '-'
		rcall 	lcd_data
		neg		r0					;two's complement
_dte2:	mov		a0, r0
		lsr		a0					; / 2
		rcall	dec_out
		rcall	lcd_dot
		ldi		a0, '0'
		sbrc	r0, 0
		ldi		a0, '5'
		rcall	lcd_data			;display 0.5 degree
		ldi 	a0,	0xDF
		rcall 	lcd_data
		ldi 	a0,	'C'
		rcall 	lcd_data
_dte3:	ldi 	a0,	' '
		rcall 	lcd_data
		ldi 	a0,	' '
		rcall 	lcd_data
		ldi 	a0,	' '
		rcall 	lcd_data
		ldi 	a0,	' '
		rcall 	lcd_data
		cpi		lcd_count, 10
		breq	_dte1				;get 2. reading
		ldi 	a0, 0b11000000      ;2te Zeile
		rcall 	lcd_command
		cpi		lcd_count, 20
		breq	_dte1				;get 3. reading
		ret

ZU:		ldi 	a0, 0b11001000      
		rcall 	lcd_command
		ldi 	a0, 'V'
		rcall 	lcd_data
		ldi 	a0, 'e'
		rcall 	lcd_data
		ldi 	a0, 'n'
		rcall 	lcd_data
		ldi 	a0, 't'
		rcall 	lcd_data
		ldi 	a0, '.'
		rcall 	lcd_data
		ldi 	a0, ' '
		rcall 	lcd_data
		ldi 	a0, 'Z'
		rcall 	lcd_data
		ldi 	a0, 'U'
		rcall 	lcd_data
		ret

AUF:	ldi 	a0, 0b11001000      
		rcall 	lcd_command
		ldi 	a0, 'V'
		rcall 	lcd_data
		ldi 	a0, 'e'
		rcall 	lcd_data
		ldi 	a0, 'n'
		rcall 	lcd_data
		ldi 	a0, 't'
		rcall 	lcd_data
		ldi 	a0, '.'
		rcall 	lcd_data
		ldi 	a0, 'A'
		rcall 	lcd_data
		ldi 	a0, 'U'
		rcall 	lcd_data
		ldi 	a0, 'F'
		rcall 	lcd_data
		ret
